#pragma once
#include <windows.h>
#include <string>
#include "ModelCaller.h"

typedef int(__cdecl *MYPROC)(LPWSTR);
typedef void(__cdecl *PFMC)(COUNTS *mc);
typedef void(__cdecl *PFMM)(MODELMD *mm);
typedef void(__cdecl *PFIM)(FIELDMD *fd);
typedef void(__cdecl *PFOM)(FIELDMD *fd);
typedef void(__cdecl *PSCR)(PARM *indata, PARM *outdata);

class DynamicCaller : public Caller {
private:
	HINSTANCE scoreDll;
	PFMC p_fillMetadataCounts;
	PFMM p_fillModelMetadata;
	PFIM p_fillInputMetadata;
	PFOM p_fillOutputMetadata;
	PSCR p_score;

public:
	DynamicCaller(std::wstring& dllName);
	virtual ~DynamicCaller();
	bool isValid() override;

	//Implements a wrapper around the JMP generated API suitable for dynamic linking
	void fillMetadataCounts(COUNTS *mc) override;
	void fillModelMetadata(MODELMD *mm) override;
	void fillInputMetadata(FIELDMD *fd) override;
	void fillOutputMetadata(FIELDMD *fd) override;
	void score(PARM *indata, PARM *outdata) override;
};
