#include "jmp_score.h"
#include "jmp_lib.h"


/* ==================================================================
 Copyright(C) 2016 SAS Institute Inc.All rights reserved.
 
 Notice:
 The following permissions are granted provided that the
 above copyright and this notice appear in the score code and
 any related documentation.Permission to copy, modify
 and distribute the score code generated using
 JMP(R) software is limited to customers of SAS Institute Inc. ("SAS")
 and successive third parties, all without any warranty, express or
 implied, or any other obligation by SAS.SAS and all other SAS
 Institute.Inc.product and service names are registered
 trademarks or trademarks of SAS Institute Inc.in the USA
 and other countries.Except as contained in this notice,
 the name of the SAS Institute Inc. and JMP shall not be used in
 the advertising or promotion of products or services without
 prior written authorization from SAS Institute Inc.
 ================================================================== */

/* C code generated by JMP v13.0.0 */

JMP_SCORE_API void fillMetadataCounts(COUNTS *mc) {
	mc->creatorLen       = 21;
	mc->modelNameLen     = 1;
	mc->predictedLen     = 8;
	mc->tableNameLen     = 1;
	mc->versionLen       = 7;
	mc->timestampLen     = 21;
	mc->maxInputNameLen  = 13;
	mc->maxOutputNameLen = 20;
	mc->numInputs        = 4;
	mc->numOutputs       = 4;
}

JMP_SCORE_API void fillModelMetadata(MODELMD *mm) {
	strcpy_safe(mm->creator,   "Fit Nominal Logistic"); 
	strcpy_safe(mm->modelName, ""); 
	strcpy_safe(mm->predicted, "Species"); 
	strcpy_safe(mm->tableName, ""); 
	strcpy_safe(mm->version,   "13.0.0");
    strcpy_safe(mm->timestamp, "2016-04-21T22:25:40Z");
}

JMP_SCORE_API void fillInputMetadata(FIELDMD *fd) {
    strcpy_safe(fd[0].name, "Sepal length");
    fd[0].type = fnum_type;
    fd[0].datalen = 0;        

    strcpy_safe(fd[1].name, "Sepal width");
    fd[1].type = fnum_type;
    fd[1].datalen = 0;        

    strcpy_safe(fd[2].name, "Petal length");
    fd[2].type = fnum_type;
    fd[2].datalen = 0;        

    strcpy_safe(fd[3].name, "Petal width");
    fd[3].type = fnum_type;
    fd[3].datalen = 0;        
}

JMP_SCORE_API void fillOutputMetadata(FIELDMD *fd) {
    strcpy_safe(fd[0].name, "Prob[setosa]");
    fd[0].type = fnum_type;
    fd[0].datalen = 0;        

    strcpy_safe(fd[1].name, "Prob[versicolor]");
    fd[1].type = fnum_type;
    fd[1].datalen = 0;        

    strcpy_safe(fd[2].name, "Prob[virginica]");
    fd[2].type = fnum_type;
    fd[2].datalen = 0;        

    strcpy_safe(fd[3].name, "Most Likely Species");
    fd[3].type = char_type;
    fd[3].datalen = 11;        
}

#define SEPAL_LENGTH indata[0].data.fnum
#define SEPAL_WIDTH  indata[1].data.fnum
#define PETAL_LENGTH indata[2].data.fnum
#define PETAL_WIDTH  indata[3].data.fnum

#define PROB_SETOSA_        outdata[0].data.fnum
#define PROB_VERSICOLOR_    outdata[1].data.fnum
#define PROB_VIRGINICA_     outdata[2].data.fnum
#define MOST_LIKELY_SPECIES outdata[3].data.str  // max string length: 10

JMP_SCORE_API void score(PARM *indata, PARM *outdata) {
    double Lin_setosa_;
    double _temp0 = 35.3766394147824;
    double Lin_versicolor_;
    double _temp1 = 42.6378038130224;
    int _temp2;
    double _temp3[3];
    char * _temp4 = "";

    _temp0 += 9.62781264880625 * SEPAL_LENGTH;
    _temp0 += 12.3547679702871 * SEPAL_WIDTH;
    _temp0 += -23.1998673246776 * PETAL_LENGTH;
    _temp0 += -34.0878433584342 * PETAL_WIDTH;
    Lin_setosa_ = _temp0;

    _temp1 += 2.46522019518668 * SEPAL_LENGTH;
    _temp1 += 6.68088701407859 * SEPAL_WIDTH;
    _temp1 += -9.42938515392672 * PETAL_LENGTH;
    _temp1 += -18.2861368878511 * PETAL_WIDTH;
    Lin_versicolor_ = _temp1;

    PROB_SETOSA_ = 1 / (1 + exp(-(Lin_setosa_)) + exp((Lin_versicolor_ - Lin_setosa_)));

    PROB_VERSICOLOR_ = 1 / (1 + exp((Lin_setosa_ - Lin_versicolor_)) + exp(-(Lin_versicolor_)));

    PROB_VIRGINICA_ = 1 / (1 + exp(Lin_setosa_) + exp(Lin_versicolor_));

    _temp3[0] = PROB_SETOSA_;
    _temp3[1] = PROB_VERSICOLOR_;
    _temp3[2] = PROB_VIRGINICA_;
    _temp2 = jmp_max_array(3, _temp3);
    switch (_temp2) {
        case 0: {
            _temp4 = "setosa";
        }
        break;
        case 1: {
            _temp4 = "versicolor";
        }
        break;
        case 2: {
            _temp4 = "virginica";
        }
        break;
        default: {
            _temp4 = "";
        }
    }
    strcpy_safe(MOST_LIKELY_SPECIES, _temp4);

}


