
#include "DynamicCaller"
#include "jmp_score.h"
#include "C:\home\dev\JMP\Iris\DynCaller\DynamicCaller.h"
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include <map>

#include <windows.h> 
#include <stdio.h> 
#include <fstream>
#include <iostream>
#include <memory>

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::string;
using std::vector;

//class DynamicCaller : public Caller 
//public:

DynamicCaller::DynamicCaller(std::wstring& dllName) : scoreDll(nullptr), Caller() {
	if (dllName.empty()) {
		cerr << "Error: No DLL provided." << endl;
		cerr << "Please specify one with --dll <PATH>";
		return;
	}

	scoreDll = LoadLibrary(dllName.c_str());
	if (scoreDll == nullptr) {
		cerr << "Error: Can't find given DLL "; std::wcerr << dllName << endl;
		cerr << "Try copying it to the same directory as the executable or specifying the whole path." << endl;
		return;
	}
	p_fillMetadataCounts = (PFMC)GetProcAddress(scoreDll, "fillMetadataCounts");
	p_fillModelMetadata = (PFMM)GetProcAddress(scoreDll, "fillModelMetadata");
	p_fillInputMetadata = (PFIM)GetProcAddress(scoreDll, "fillInputMetadata");
	p_fillOutputMetadata = (PFOM)GetProcAddress(scoreDll, "fillOutputMetadata");
	p_score = (PSCR)GetProcAddress(scoreDll, "score");
}

DynamicCaller::~DynamicCaller() {
	if (scoreDll != nullptr) {
		FreeLibrary(scoreDll);
	}
}

bool DynamicCaller::isValid() {
	return scoreDll != nullptr &&
		p_fillMetadataCounts != nullptr &&
		p_fillModelMetadata != nullptr &&
		p_fillInputMetadata != nullptr &&
		p_fillOutputMetadata != nullptr &&
		p_score != nullptr;
}

//Implements a wrapper around the JMP generated API suitable for dynamic linking
void DynamicCaller::fillMetadataCounts(COUNTS *mc) {
	(p_fillMetadataCounts)(mc);
}
void DynamicCaller::fillModelMetadata(MODELMD *mm) {
	(p_fillModelMetadata)(mm);
}
void DynamicCaller::fillInputMetadata(FIELDMD *fd) {
	(p_fillInputMetadata)(fd);
}
void DynamicCaller::fillOutputMetadata(FIELDMD *fd) {
	(p_fillOutputMetadata)(fd);
}
void DynamicCaller::score(PARM *indata, PARM *outdata) {
	(p_score)(indata, outdata);
}

