from flask import Flask, request, json, send_from_directory
#from flask_cors import CORS, cross_origin
import Iris_logistic as jmp
import os

# set the project root directory as the static folder, you can set others.
app = Flask(__name__, static_folder='webapp') # default will load from 'static'
root_dir = os.path.dirname(os.getcwd())
static_dir = os.path.join(root_dir, 'webapp')

@app.route('/score', methods = ['GET','POST'])
def score():
	input = read_args()
	print "input: " + json.dumps(input)
	result = {}
	# check for missing and invalid args
	if len(input[1]) > 0 or len(input[2]) > 0:
		result["input error"] = input
	else:
		out = {}
		try:
			jmp.score(input[0], out)
			result["success"] = out 
		except OverflowError:
			result["processing error"] = input[0] 

	s = json.dumps(result)
	print "output: " + s
	return s

@app.route('/')
def root():
	print("root")
	return app.send_static_file('index.html')

@app.route('/<path:path>')
def root_file(path):
	print("root " + path)
	return app.send_static_file(path)

def read_args():
	indata = {}
	missing = {}
	invalid = {}
	in_meta = jmp.getInputMetadata()
	for k,v in in_meta.iteritems():
		if k not in request.args:
			missing[k] = v
		else:
			try: 
				if v == "float":
					indata[k] = float(request.args[k])
				elif v == "int":
					indata[k] = int(request.args[k])
				else: # v == "str":
					indata[k] = request.args[k]
			except:
				invalid[k] = (v, request.args[k])
	return (indata, missing, invalid)

if __name__ == '__main__':
	app.run(host='0.0.0.0', port=9004) 
