"use strict";

function capitalizeFirstLetter(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}

function changeImage(species) {
  var title = document.getElementById("iris_title");
  title.innerHTML = capitalizeFirstLetter(species);
  var pic = document.getElementById("iris_pic");
  pic.src = "images/Iris_" + species + ".jpg";
}

function fillForm() {
  fillFormById(this.id);
}

function fillFormById(id) {
  var sl, sw, pl, pw;
  switch(id) {
  case "s1":
   sl = 5.1; sw = 3.5; pl = 1.4; pw = 0.2; break;
  case "s2":
   sl = 4.9; sw = 3.0; pl = 1.4; pw = 0.2; break;
  case "v1":
   sl = 7.0; sw = 3.2; pl = 4.7; pw = 1.4; break;
  case "v2":
   sl = 6.4; sw = 3.2; pl = 4.5; pw = 1.5; break;
  case "i1":
   sl = 6.3; sw = 3.3; pl = 6.0; pw = 2.5; break;
  case "i2":
   sl = 5.8; sw = 2.7; pl = 5.1; pw = 1.9; break;
  case "s1":
   sl = 5.8; sw = 2.7; pl = 5.1; pw = 1.9; break;
   default:
    sl = ""; sw = ""; pl = ""; pw = ""; 
  }

  document.getElementById("petal_length").value = pl;
  document.getElementById("sepal_length").value = sl;
  document.getElementById("sepal_width").value = sw;
  document.getElementById("petal_width").value = pw;
}

function scoreForm(e) {
  if (e.preventDefault) {
     e.preventDefault();
  }
  e.returnValue = false; // for IE

  var indata = {
    "Petal length": document.getElementById("petal_length").value,
    "Sepal length": document.getElementById("sepal_length").value,
    "Sepal width": document.getElementById("sepal_width").value,
    "Petal width": document.getElementById("petal_width").value
  };
  
  var irisAPI = "./score";
  $.getJSON( irisAPI, indata)
    .done(function( data ) {
      if (data.hasOwnProperty("success")) {
        var outdata = data["success"];
        changeImage(outdata["Most Likely Species"]);
      } else {
        console.log( "Server error: " + JSON.stringify(data) );
      }
    })
    .fail(function() {
      console.log( "AJAX error!" );
    })
    .always(function() {
      console.log( "Done." );
    });
  return false;
}

document.addEventListener("DOMContentLoaded", function(event) { 
    var theForm = document.getElementById('score_form');
    theForm.addEventListener("submit", scoreForm, false);

    $('.cheat_link').click(fillForm);
    $('.collapse').collapse();
});

// module.exports = {
//   scoreForm: scoreForm
// };


