"use strict";

var model = require('./Iris_bootstrap.js');
var prompt = require('prompt');

var indata = {};
var outdata = {};
var keys = [];
var types = [];

prompt.start();
var input_md = model.getInputMetadata().properties;
console.log(input_md);
for (var key in input_md) {
    if (input_md.hasOwnProperty(key)) {
        keys.push(key);
        types.push(input_md[key].type);
    }
}
prompt.get(keys, function (err, result) {
  if (err) { return onErr(err); }
  var len = keys.length; 
  for (var i = 0; i < len; ++i) {    
    var ikey = keys[i];
    var vtype = types[i];
    if (vtype == "number")
        indata[ikey] = parseFloat(result[ikey]);
    else
        indata[ikey] = result[ikey];
  }

  model.score(indata, outdata);

  var output_md = model.getOutputMetadata().properties;
  console.log(output_md);
  for (var okey in output_md) {
    if (output_md.hasOwnProperty(okey)) {
      console.log("Predicted: " + okey + " = " + outdata[okey]);
    }
  }
});

function onErr(err) {
  console.log(err);
  return 1;
}



